#include <string>
#include <sys/types.h>
#include <errno.h>
#include <unistd.h>
#ifndef errno
extern int errno;
#endif

/* I hacked this code by studying the sh-utils sources */
/* The original xgetcwd returns an character pointer. This 
   function returns a string */
std::string xgetcwd()
{
  const unsigned int PATH_MAX = 100;
  const unsigned int PATH_INC = PATH_MAX;

  unsigned int path_max = PATH_MAX;
  path_max += 2;		/* The getcwd docs say to do this. */

  char* cwd = static_cast<char*>(malloc(path_max));

  errno = 0;
  char* ret;
  while ((ret = getcwd (cwd, path_max)) == NULL && errno == ERANGE)
    {
      path_max += PATH_INC;
      cwd = static_cast<char*>(realloc (cwd, path_max));
      errno = 0;
    }

  if (ret == NULL)
    {
      int save_errno = errno;
      free (cwd);
      errno = save_errno;
      return "";
    }

  std::string s = cwd;
  free( cwd );

  return s;
};
